#include <pic.h>
#include "LCD_Defs.h"


void Initialize_CPU(void) ;
void Delay_Long(void) ;
void Delay_Second(int);

// ************ ]w PIC16F1937 Configuration Bits  ******
// ]wѼƽаѦ pic16f1937.h ɮתe
//
__CONFIG  ( FOSC_INTOSC & WDTE_OFF & PWRTE_OFF & MCLRE_ON & CP_OFF & BOREN_OFF & CLKOUTEN_ON
		   & IESO_OFF & FCMEN_OFF); 
__CONFIG ( VCAPEN_OFF & PLLEN_ON & STVREN_OFF & BORV_25 & LVP_OFF);



int	Dig1;
unsigned char 	x;


void main(void)
{
	
	    OSCCON = 0x70 ;			// 8MHz x4PLL = 32MHz
		GIE=0;					// we don't want interrupts now !!

		Initialize_LCD() ;

// Digital 1 ̥䪺UơADigital 5 Ӧƪ					

	
		DisplayDigit5(8) ;		// ӼƦr 8 ẶA 8AƤT
		DisplayDigit4(8) ;		
		DisplayDigit3(8) ;
		DisplayDigit2(8) ;
		DisplayDigit1(8) ;
		Delay_Second(10);		// Delay 10 x 50ms = 0.5 Sec
		Clear_LCD( );
		Delay_Second(10);

		DisplayDigit5(8) ;
		DisplayDigit4(8) ;		
		DisplayDigit3(8) ;
		DisplayDigit2(8) ;
		DisplayDigit1(8) ;
		Delay_Second(10);
		Clear_LCD( );
		Delay_Second(10);

		DisplayDigit5(8) ;
		DisplayDigit4(8) ;		
		DisplayDigit3(8) ;
		DisplayDigit2(8) ;
		DisplayDigit1(8) ;
		Delay_Second(10);
		Clear_LCD( );
		Delay_Second(10);

		

	while(1)
	{ 
 		DisplayDigit1(1) ;SEG_1DP=1 ; 		//  1, 3, 5, 7, 9 
		Delay_Second(5);
		DisplayDigit2(3) ;SEG_2DP=1 ;	
		Delay_Second(5);	
		DisplayDigit3(5) ;SEG_3DP=1 ;
		Delay_Second(5);
		DisplayDigit4(7) ;SEG_4DP=1 ;
		Delay_Second(5);
		DisplayDigit5(9) ;
		Delay_Second(5); 

		SEG_BAT = 1;						// ܯSrŸ
		Delay_Second(5);
		SEG_HOLD = 1;
		Delay_Second(5);
		SEG_REC = 1;
		Delay_Second(5);
		SEG_Max = 1;
		Delay_Second(5);
		SEG_S1= 1;
		Delay_Second(5);
		SEG_S2= 1;
		Delay_Second(5);
		SEG_m= 1;
		Delay_Second(5);
		SEG_V = 1;
		Delay_Second(5);
		SEG_oF = 1;
		Delay_Second(5);
		SEG_oC = 1;
		Delay_Second(5);
		SEG_Slow = 1;
		Delay_Second(5);
		SEG_C = 1;
		Delay_Second(5);
		SEG_Fast = 1;
		Delay_Second(5);
		SEG_A = 1;
		Delay_Second(10);


		BlankDigit1( ) ;SEG_1DP=0 ;		// Ʀr 1,3,5,7,9
		Delay_Second(5);
		BlankDigit2( ) ;SEG_2DP=0 ;	
		Delay_Second(5);	
		BlankDigit3( ) ;SEG_3DP=0 ;
		Delay_Second(5);
		BlankDigit4( ) ;SEG_4DP=0 ;
		Delay_Second(5);
		BlankDigit5( ) ; 
		Delay_Second(5); 

		for (Dig1=0; Dig1<16; Dig1++)  //  0 ~ F
		{
			DisplayDigit5(Dig1) ;
			DisplayDigit4(Dig1) ;		
			DisplayDigit3(Dig1) ;
			DisplayDigit2(Dig1) ;
			DisplayDigit1(Dig1) ;
			Delay_Second(10);
		}
		Clear_LCD( );					// Ҧ LCD 
		Delay_Second(10);
	}
}	

	

void Delay_Second(int Delay_Count)
{
	unsigned char i;

	for (i=0;i<= Delay_Count; i++)
	{
		Delay_Long() ;
	}
}



void Delay_Long(void)  // Delay 50mS at 32MHz
{
	int		Delay1 ; 

	for ( Delay1 = 0 ; Delay1 < 23515 ; Delay1 ++ ) ;
}


