#include <pic.h>
#include "LCD_Defs.h"
#include "Main.h"

union		 
{ 	
	unsigned int Word;
	unsigned char Byte[2] ;
}ADC_Result; 

unsigned long Temp_Buff;
unsigned int Disp_Temp;

extern unsigned char Disp_Count;
extern unsigned char Key_Input;


void Show_ADC_Voltage(void )
{
//	Disp_Count = 20;			// ]wC 100mS ܹq@ 
	Clear_LCD( );

	do	
	{
		if (Disp_Count==0)		// 100mS F? {|C 100mS s LCD W VR2 q@
		{
	 		Read_ADC();								// Ū ADC (VR2) ഫ
			Temp_Buff= ADC_Result.Word & 0x3FF;		// NLΦ줸B\ 0
			Disp_Temp=(((unsigned long)Temp_Buff)*4883)/100; 	// 10-bit ѪRסA1 LSB=4.883mV
	  												// Xڹqè 0.1mV
	
  			DisplayDigit1(Disp_Temp/10000);			//  V LCD Ĥ@ƦrW
			Disp_Temp=Disp_Temp%10000;				// Xl
				
 			DisplayDigit2(Disp_Temp/1000 );			//  100mV	
			Disp_Temp=Disp_Temp%1000;				 
	
			DisplayDigit3(Disp_Temp/100);			//  10mV
			Disp_Temp=Disp_Temp%100;
	
			DisplayDigit4(Disp_Temp/10);			//  mV
			Disp_Temp=Disp_Temp%10;
	
			DisplayDigit5(Disp_Temp);				//  0.1mV
	
		 	SEG_4DP=1 ;								// IpI
	
  			SEG_m = !SEG_m;								//  mV Ÿ
			SEG_V= !SEG_V;
//			SEG_BAT=!SEG_BAT;

			Disp_Count = 20;						// ]wC 100mS ܹq@ 
		} 
	} while (Key_Input == 0);			// j餺ˬdO_sU? YLh~ܹq									//YhXܹq
	
	Clear_LCD( );
}

void Read_ADC(void)
{
	unsigned char i;

	GO_nDONE = 1 ;
//	NOP( );
//	while(GO_nDONE);
	for(i=0;i<30;i++) ;			// Delay 42uS for Conversion

	ADC_Result.Byte[0] = ADRESL ;  // Get 10-bit ADC Result
	ADC_Result.Byte[1] = ADRESH ;
}

void Initialize_ADC(void)
{
	TRISB2 = 1; 			// Set RB2 as Input pin
	ANSB2 = 1; 				// Set RB2/AN8 as Analog input function pin
	ADCON0 = 0b00100001;  	// ADC Enable, Select AN8 for VR2 input (RB2/AN8)
	ADCON1 = 0b11100000;  	// Right Justified, Fosc/64, Vref- to Vss, Vref+ to Vdd
	ADIF = 0;
}

